diff --git a/pkgs/geospatial/polyvectorization/default.nix b/pkgs/by-name/po/polyvectorization/package.nix
rename from pkgs/geospatial/polyvectorization/default.nix
rename to pkgs/by-name/po/polyvectorization/package.nix
index 34dfa9173f3dd51d3e1ae8df9a221372a1b5fccc..098fc135fc3b81dedcb340d9d93b6cd59a78cf86 100644
--- a/pkgs/geospatial/polyvectorization/default.nix
+++ b/pkgs/by-name/po/polyvectorization/package.nix
@@ -6,7 +6,7 @@   cmake,
   boost,
   eigen,
   opencv,
-  wrapQtAppsHook,
+  qt5,
 }:
 
 stdenv.mkDerivation {
@@ -29,7 +29,7 @@   '';
 
   nativeBuildInputs = [
     cmake
-    wrapQtAppsHook
+    qt5.wrapQtAppsHook
   ];
 
   buildInputs = [
diff --git a/pkgs/geospatial/qlandkartegt/default.nix b/pkgs/by-name/ql/qlandkartegt/package.nix
rename from pkgs/geospatial/qlandkartegt/default.nix
rename to pkgs/by-name/ql/qlandkartegt/package.nix
index 32cdd364c5fb9d1afd742a89ed3aaca2b9905a8e..3f6ff276191fc1c2718cb76bc60dde73b5638324 100644
--- a/pkgs/geospatial/qlandkartegt/default.nix
+++ b/pkgs/by-name/ql/qlandkartegt/package.nix
@@ -4,18 +4,16 @@   lib,
   fetchurl,
   fetchpatch,
   cmake,
-  qtmultimedia,
-  qtserialport,
-  qtscript,
-  qtwebkit,
-  wrapQtAppsHook,
+  qt5,
   garmindev,
   gdal,
   gpsd,
   libdmtx,
   libexif,
+  libgeotiff,
   libGLU,
-  proj,
+  libspatialite,
+  proj_7,
 }:
 
 stdenv.mkDerivation (finalAttrs: {
@@ -68,21 +66,25 @@   ];
 
   nativeBuildInputs = [
     cmake
-    wrapQtAppsHook
+    qt5.wrapQtAppsHook
   ];
 
   buildInputs = [
-    qtmultimedia
-    qtserialport
-    qtscript
-    qtwebkit
+    qt5.qtmultimedia
+    qt5.qtserialport
+    qt5.qtscript
+    qt5.qtwebkit
     garmindev
-    gdal
+    (gdal.override {
+      libgeotiff = libgeotiff.override { proj = proj_7; };
+      libspatialite = libspatialite.override { proj = proj_7; };
+      proj = proj_7;
+    })
     gpsd
     libdmtx
     libexif
     libGLU
-    proj
+    proj_7
   ];
 
   cmakeFlags = [
diff --git a/pkgs/geospatial/render_geojson/default.nix b/pkgs/by-name/re/render_geojson/package.nix
rename from pkgs/geospatial/render_geojson/default.nix
rename to pkgs/by-name/re/render_geojson/package.nix
index 41e159047a5b1fa06ff7972c4cadc4c42d33a16e..723468ac91ed47f4e23bb3f2f52f22cecb3cefb3 100644
--- a/pkgs/geospatial/render_geojson/default.nix
+++ b/pkgs/by-name/re/render_geojson/package.nix
@@ -3,7 +3,7 @@   lib,
   stdenv,
   fetchFromGitHub,
   autoreconfHook,
-  wxGTK,
+  wxGTK32,
 }:
 
 stdenv.mkDerivation (finalAttrs: {
@@ -19,7 +19,7 @@   };
 
   nativeBuildInputs = [ autoreconfHook ];
 
-  buildInputs = [ wxGTK ];
+  buildInputs = [ wxGTK32 ];
 
   meta = {
     description = "C++ geoJSON and topoJSON parser and rendering using the WxWidgets GUI library";
diff --git a/pkgs/gnss/visualgps/default.nix b/pkgs/by-name/vi/visualgps/package.nix
rename from pkgs/gnss/visualgps/default.nix
rename to pkgs/by-name/vi/visualgps/package.nix
index 49ce42e5c57e7ca9ea30b52e5083d43b86937826..01d79a648b96456e50ea53c6afdcaf1803667a8d 100644
--- a/pkgs/gnss/visualgps/default.nix
+++ b/pkgs/by-name/vi/visualgps/package.nix
@@ -2,9 +2,7 @@ {
   lib,
   stdenv,
   fetchFromGitHub,
-  qmake,
-  qtserialport,
-  wrapQtAppsHook,
+  qt5,
 }:
 
 stdenv.mkDerivation {
@@ -20,11 +18,11 @@     fetchSubmodules = true;
   };
 
   nativeBuildInputs = [
-    qmake
-    wrapQtAppsHook
+    qt5.qmake
+    qt5.wrapQtAppsHook
   ];
 
-  buildInputs = [ qtserialport ];
+  buildInputs = [ qt5.qtserialport ];
 
   qmakeFlags = [ "Software/VisualGPSqt/Source/VisualGPSqt.pro" ];
 
diff --git a/pkgs/gpx/gpx-layer/default.nix b/pkgs/by-name/gp/gpx-layer/package.nix
rename from pkgs/gpx/gpx-layer/default.nix
rename to pkgs/by-name/gp/gpx-layer/package.nix
index a26330111d38b5b7d0c3a3a30afb4f86965d9e20..6194e43395f1f38bc17bd2d582892e53a8875cd4 100644
--- a/pkgs/gpx/gpx-layer/default.nix
+++ b/pkgs/by-name/gp/gpx-layer/package.nix
@@ -2,12 +2,11 @@ {
   lib,
   stdenv,
   fetchFromGitHub,
-  buildPerlPackage,
+  perlPackages,
   shortenPerlShebang,
-  XMLParser,
 }:
 
-buildPerlPackage {
+perlPackages.buildPerlPackage {
   pname = "gpx-layer";
   version = "0-unstable-2013-09-19";
 
@@ -22,7 +21,7 @@   outputs = [ "out" ];
 
   nativeBuildInputs = lib.optional stdenv.isDarwin shortenPerlShebang;
 
-  propagatedBuildInputs = [ XMLParser ];
+  propagatedBuildInputs = [ perlPackages.XMLParser ];
 
   preConfigure = "touch Makefile.PL";
 
diff --git a/pkgs/misc/capture2text/default.nix b/pkgs/by-name/ca/capture2text/package.nix
rename from pkgs/misc/capture2text/default.nix
rename to pkgs/by-name/ca/capture2text/package.nix
index 4a2a06878a040fec02e0125f09ac9241a0042031..5dc7063856f7f1a5bd7d4fb2dfc53ae3d6668ce7 100644
--- a/pkgs/misc/capture2text/default.nix
+++ b/pkgs/by-name/ca/capture2text/package.nix
@@ -2,11 +2,10 @@ {
   lib,
   stdenv,
   fetchurl,
-  qmake,
+  qt5,
   unzip,
   leptonica,
   tesseract4,
-  wrapQtAppsHook,
 }:
 
 stdenv.mkDerivation (finalAttrs: {
@@ -48,9 +47,9 @@     tesseract4
   ];
 
   nativeBuildInputs = [
-    qmake
     unzip
-    wrapQtAppsHook
+    qt5.qmake
+    qt5.wrapQtAppsHook
   ];
 
   qmakeFlags = [
diff --git a/pkgs/misc/modbus_sim_cli/default.nix b/pkgs/by-name/mo/modbus_sim_cli/package.nix
rename from pkgs/misc/modbus_sim_cli/default.nix
rename to pkgs/by-name/mo/modbus_sim_cli/package.nix
index d5e98a1c2f9598469d5cf6aaba14f737d129cb4a..6586e842b6f18f3c463344046de90725a24222cb 100644
--- a/pkgs/misc/modbus_sim_cli/default.nix
+++ b/pkgs/by-name/mo/modbus_sim_cli/package.nix
@@ -1,11 +1,11 @@
 {
   lib,
-  python3Packages,
+  python310Packages,
   fetchFromGitHub,
   writableTmpDirAsHomeHook,
 }:
 
-python3Packages.buildPythonApplication {
+python310Packages.buildPythonApplication {
   pname = "modbus_sim_cli";
   version = "0-unstable-2019-02-27";
   pyproject = true;
@@ -23,11 +23,11 @@     substituteInPlace modbus_sim/utils/config_parser.py \
       --replace-fail "yaml.load(conffile.read())" "yaml.safe_load(conffile)"
   '';
 
-  build-system = with python3Packages; [ setuptools ];
+  build-system = with python310Packages; [ setuptools ];
 
   nativeBuildInputs = [ writableTmpDirAsHomeHook ];
 
-  dependencies = with python3Packages; [
+  dependencies = with python310Packages; [
     coloredlogs
     modbus-tk
     pyyaml
diff --git a/pkgs/misc/ocelotgui/default.nix b/pkgs/by-name/oc/ocelotgui/package.nix
rename from pkgs/misc/ocelotgui/default.nix
rename to pkgs/by-name/oc/ocelotgui/package.nix
index 405960385ca8305184d5be2c693e74920cfb9828..ae0f992f68684bdac58468973bd5c184ee0165cf 100644
--- a/pkgs/misc/ocelotgui/default.nix
+++ b/pkgs/by-name/oc/ocelotgui/package.nix
@@ -5,7 +5,7 @@   fetchFromGitHub,
   cmake,
   desktopToDarwinBundle,
   mariadb-connector-c,
-  wrapQtAppsHook,
+  qt5,
 }:
 
 stdenv.mkDerivation (finalAttrs: {
@@ -21,7 +21,7 @@   };
 
   nativeBuildInputs = [
     cmake
-    wrapQtAppsHook
+    qt5.wrapQtAppsHook
   ] ++ lib.optional stdenv.isDarwin desktopToDarwinBundle;
 
   buildInputs = [ mariadb-connector-c ];
diff --git a/pkgs/misc/opcua-stack/default.nix b/pkgs/by-name/op/opcua-stack/package.nix
rename from pkgs/misc/opcua-stack/default.nix
rename to pkgs/by-name/op/opcua-stack/package.nix
index a0dbf6e878dadb50cd1c71877c0ec062f70bf6ba..b3fb3580d8a17f0f99c076392802564d41674a34 100644
--- a/pkgs/misc/opcua-stack/default.nix
+++ b/pkgs/by-name/op/opcua-stack/package.nix
@@ -3,31 +3,33 @@   lib,
   stdenv,
   fetchFromGitHub,
   cmake,
-  boost,
+  boost179,
   openssl,
 }:
 
 stdenv.mkDerivation (finalAttrs: {
   pname = "opcua-stack";
-  version = "3.8.1";
+  version = "4.0.0";
 
   src = fetchFromGitHub {
     owner = "ASNeG";
     repo = "OpcUaStack";
     tag = finalAttrs.version;
-    hash = "sha256-czpuuT9DeZaYo2Q8Y/vW1kAsIiFhRDSKwVBUcFgb9iQ=";
+    hash = "sha256-/PiawQ3kXK4wB/PxQ5EJJsuOOFZdkr/BeQ3zbl7N7fs=";
   };
 
   sourceRoot = "${finalAttrs.src.name}/src";
 
   postPatch = ''
     substituteInPlace CMakeLists.txt --replace-fail "/usr" "$out"
+    substituteInPlace OpcUaStackCore/CMakeLists.txt --replace-fail "/usr" "$out"
+    substituteInPlace OpcUaStackServer/CMakeLists.txt --replace-fail "/usr" "$out"
   '';
 
   nativeBuildInputs = [ cmake ];
 
   buildInputs = [
-    boost
+    boost179
     openssl
   ];
 
diff --git a/pkgs/misc/plotjuggler/default.nix b/pkgs/by-name/pl/plotjuggler/package.nix
rename from pkgs/misc/plotjuggler/default.nix
rename to pkgs/by-name/pl/plotjuggler/package.nix
index 1231d6093bc42d2884777d1ad4953ca589317d17..0887cdbdc3d088edea13e63862be6837864e5c67 100644
--- a/pkgs/misc/plotjuggler/default.nix
+++ b/pkgs/by-name/pl/plotjuggler/package.nix
@@ -4,10 +4,7 @@   stdenv,
   fetchFromGitHub,
   cmake,
   desktopToDarwinBundle,
-  wrapQtAppsHook,
-  qtsvg,
-  qtwebsockets,
-  qtx11extras,
+  qt5,
   mosquitto,
   libdwarf,
   protobuf,
@@ -35,18 +32,18 @@   '';
 
   nativeBuildInputs = [
     cmake
-    wrapQtAppsHook
+    qt5.wrapQtAppsHook
   ] ++ lib.optional stdenv.isDarwin desktopToDarwinBundle;
 
   buildInputs = [
-    qtsvg
-    qtwebsockets
+    qt5.qtsvg
+    qt5.qtwebsockets
     mosquitto
     libdwarf
     protobuf
     zeromq
     zstd
-  ] ++ lib.optionals stdenv.isLinux [ qtx11extras ];
+  ] ++ lib.optionals stdenv.isLinux [ qt5.qtx11extras ];
 
   meta = {
     description = "The Time Series Visualization Tool";
diff --git a/pkgs/misc/worm/default.nix b/pkgs/by-name/wo/worm/package.nix
rename from pkgs/misc/worm/default.nix
rename to pkgs/by-name/wo/worm/package.nix
index 192cb2fc00d7702d3ad5d24269ce641a4e994061..897906a904a8fabd472d3efc6d76c9c1b4188adf 100644
--- a/pkgs/misc/worm/default.nix
+++ b/pkgs/by-name/wo/worm/package.nix
@@ -1,39 +1,32 @@
 {
   lib,
   stdenv,
-  nimPackages,
+  buildNimPackage,
   fetchFromGitHub,
   pkg-config,
   xorg,
 }:
 
-nimPackages.buildNimPackage rec {
+buildNimPackage rec {
   pname = "worm";
-  version = "0.3.2";
-  nimBinOnly = true;
+  version = "0.3.3";
 
   src = fetchFromGitHub {
     owner = "codic12";
     repo = "worm";
     tag = "v${version}";
-    hash = "sha256-fm969whcYILMphR8Vr8oarx2iEJiIhzifU2wNYaU/Kg=";
+    hash = "sha256-DnmFDFVjya24e3PcIOa0nAeKfbfCgQ73sKaNGe4zErg=";
   };
 
+  lockFile = ./lock.json;
+
   nativeBuildInputs = [ pkg-config ];
 
-  buildInputs =
-    with nimPackages;
-    [
-      pixie
-      regex
-      unicodedb
-      x11
-    ]
-    ++ (with xorg; [
-      libX11
-      libXft
-      libXinerama
-    ]);
+  buildInputs = with xorg; [
+    libX11
+    libXft
+    libXinerama
+  ];
 
   postInstall = ''
     install -Dm644 assets/worm.desktop -t $out/share/applications
diff --git a/pkgs/nakarte/map-tiler/default.nix b/pkgs/by-name/ma/map-tiler/package.nix
rename from pkgs/nakarte/map-tiler/default.nix
rename to pkgs/by-name/ma/map-tiler/package.nix
index 968389baced72dfed47a27f0c2f5b0ee2f66dd46..65ac3e4d64cd218f4e53480052901b93f627ea22 100644
--- a/pkgs/nakarte/map-tiler/default.nix
+++ b/pkgs/by-name/ma/map-tiler/package.nix
@@ -1,7 +1,7 @@
 {
   lib,
   stdenv,
-  python3Packages,
+  python311Packages,
   fetchFromGitHub,
   gobject-introspection,
   pango,
@@ -12,7 +12,7 @@   pyimagequant,
   wrapGAppsHook,
 }:
 
-python3Packages.buildPythonApplication {
+python311Packages.buildPythonApplication {
   pname = "map-tiler";
   version = "0-unstable-2022-08-06";
   pyproject = true;
@@ -32,7 +32,7 @@       --replace-fail " @ git+https://github.com/wladich/ozi_map.git" "" \
       --replace-fail " @ git+https://github.com/wladich/pyimagequant.git" ""
   '';
 
-  build-system = with python3Packages; [ setuptools ];
+  build-system = with python311Packages; [ setuptools ];
 
   nativeBuildInputs = [
     gobject-introspection
@@ -44,7 +44,7 @@     gobject-introspection
     pango
   ];
 
-  dependencies = with python3Packages; [
+  dependencies = with python311Packages; [
     pyyaml
     pyproj
     pypng
diff --git a/pkgs/nakarte/maprec/default.nix b/pkgs/by-name/ma/maprec/package.nix
rename from pkgs/nakarte/maprec/default.nix
rename to pkgs/by-name/ma/maprec/package.nix
index 431ce97db64a159dbcf1e6376b7884229a86c634..8a9c04675d06bd69f6e6308801f764c758f3190b 100644
--- a/pkgs/nakarte/maprec/default.nix
+++ b/pkgs/by-name/ma/maprec/package.nix
@@ -1,12 +1,12 @@
 {
   lib,
   stdenv,
-  python3Packages,
+  python311Packages,
   fetchFromGitHub,
   thinplatespline,
 }:
 
-python3Packages.buildPythonPackage {
+python311Packages.buildPythonPackage {
   pname = "maprec";
   version = "0-unstable-2023-04-18";
   pyproject = true;
@@ -23,9 +23,9 @@     substituteInPlace setup.py \
       --replace-fail " @ git+https://github.com/wladich/thinplatespline.git" ""
   '';
 
-  build-system = with python3Packages; [ setuptools ];
+  build-system = with python311Packages; [ setuptools ];
 
-  dependencies = with python3Packages; [
+  dependencies = with python311Packages; [
     pyyaml
     pyproj
     thinplatespline
diff --git a/pkgs/nakarte/ozi-map/default.nix b/pkgs/by-name/oz/ozi-map/package.nix
rename from pkgs/nakarte/ozi-map/default.nix
rename to pkgs/by-name/oz/ozi-map/package.nix
index e3345e1c888e96f00897e7eca2c200e56463c548..dbc32531cf696ced2c5d9775b4bfe9a9a61096ea 100644
--- a/pkgs/nakarte/ozi-map/default.nix
+++ b/pkgs/by-name/oz/ozi-map/package.nix
@@ -1,12 +1,12 @@
 {
   lib,
   stdenv,
-  python3Packages,
+  python311Packages,
   fetchFromGitHub,
   maprec,
 }:
 
-python3Packages.buildPythonPackage {
+python311Packages.buildPythonPackage {
   pname = "ozi-map";
   version = "0-unstable-2022-08-05";
   pyproject = true;
@@ -23,9 +23,9 @@     substituteInPlace setup.py \
       --replace-fail " @ git+https://github.com/wladich/maprec.git" ""
   '';
 
-  build-system = with python3Packages; [ setuptools ];
+  build-system = with python311Packages; [ setuptools ];
 
-  dependencies = with python3Packages; [
+  dependencies = with python311Packages; [
     maprec
     pyproj
   ];
diff --git a/pkgs/nakarte/pyimagequant/default.nix b/pkgs/by-name/py/pyimagequant/package.nix
rename from pkgs/nakarte/pyimagequant/default.nix
rename to pkgs/by-name/py/pyimagequant/package.nix
index 3a5c5d57663631e11caa938e5ae22563737fed0c..cb312a9a4ad1a50266719c6dca13f88fb892bd68 100644
--- a/pkgs/nakarte/pyimagequant/default.nix
+++ b/pkgs/by-name/py/pyimagequant/package.nix
@@ -2,10 +2,10 @@ {
   lib,
   stdenv,
   fetchFromGitHub,
-  python3Packages,
+  python311Packages,
 }:
 
-python3Packages.buildPythonPackage {
+python311Packages.buildPythonPackage {
   pname = "pyimagequant";
   version = "0-unstable-2022-06-10";
   pyproject = true;
@@ -23,9 +23,9 @@     # error: could not create 'build': File exists
     rm BUILD
   '';
 
-  build-system = with python3Packages; [ setuptools ];
+  build-system = with python311Packages; [ setuptools ];
 
-  dependencies = with python3Packages; [ cython ];
+  dependencies = with python311Packages; [ cython ];
 
   pythonImportsCheck = [ "imagequant" ];
 
diff --git a/pkgs/nakarte/thinplatespline/default.nix b/pkgs/by-name/th/thinplatespline/package.nix
rename from pkgs/nakarte/thinplatespline/default.nix
rename to pkgs/by-name/th/thinplatespline/package.nix
index 2b8054053578cffa0fd403895c0318afdd1dca53..dd58251d9df229f5a08673b99ed35e454afcc75e 100644
--- a/pkgs/nakarte/thinplatespline/default.nix
+++ b/pkgs/by-name/th/thinplatespline/package.nix
@@ -1,10 +1,10 @@
 {
   lib,
-  python3Packages,
+  python311Packages,
   fetchFromGitHub,
 }:
 
-python3Packages.buildPythonPackage {
+python311Packages.buildPythonPackage {
   pname = "thinplatespline";
   version = "0-unstable-2024-02-06";
   pyproject = true;
@@ -16,7 +16,7 @@     rev = "81f40c74663d9510ceedf57a04a711ec7fc8b7fa";
     hash = "sha256-1U5WEPFH5dhf2lkfZY6rrwlUNq/rY2mSlgEZVnReyng=";
   };
 
-  build-system = with python3Packages; [ setuptools ];
+  build-system = with python311Packages; [ setuptools ];
 
   doCheck = false;
 
diff --git a/pkgs/radio/fmreceiver/default.nix b/pkgs/by-name/fm/fmreceiver/package.nix
rename from pkgs/radio/fmreceiver/default.nix
rename to pkgs/by-name/fm/fmreceiver/package.nix
index f157168a20e0b15a92fce66fd840e951d7ed8719..fd90f39cca7541b60c4266d9a64181f1faa89f11 100644
--- a/pkgs/radio/fmreceiver/default.nix
+++ b/pkgs/by-name/fm/fmreceiver/package.nix
@@ -9,9 +9,8 @@   libsndfile,
   libusb1,
   portaudio,
   rtl-sdr,
-  qmake,
-  qwt,
-  wrapQtAppsHook,
+  qt5,
+  libsForQt5,
 }:
 
 stdenv.mkDerivation (finalAttrs: {
@@ -46,8 +45,8 @@       substituteInPlace devices/rtlsdr-handler/rtlsdr-handler.cpp --replace-fail ".so" ".dylib"
     '';
 
   nativeBuildInputs = [
-    qmake
-    wrapQtAppsHook
+    qt5.qmake
+    qt5.wrapQtAppsHook
   ];
 
   buildInputs = [
@@ -56,7 +55,7 @@     libsamplerate
     libsndfile
     libusb1
     portaudio
-    qwt
+    libsForQt5.qwt
   ];
 
   qmakeFlags = [ "CONFIG+=dabstick" ];
@@ -72,7 +71,7 @@     if stdenv.isDarwin then
       ''
         mkdir -p $out/Applications
         mv linux-bin/fmreceiver-2.0.app $out/Applications/fmreceiver.app
-        install_name_tool -change {,${qwt}/lib/}libqwt.6.dylib "$out/Applications/fmreceiver.app/Contents/MacOS/fmreceiver-2.0"
+        install_name_tool -change {,${libsForQt5.qwt}/lib/}libqwt.6.dylib "$out/Applications/fmreceiver.app/Contents/MacOS/fmreceiver-2.0"
       ''
     else
       ''
